from socket import *

class OpenSteer:
	def __init__(self):		
		self.__HOST = '127.0.0.1'
		self.__PORT = 20002
		self.__BUFSIZ = 1024
		self.__ADDR = (self.__HOST, self.__PORT)
		self.__connected = False
		self.__sock = socket(AF_INET, SOCK_STREAM)
		self.__buf = []
		self.__previousActors = []
		self.__busy = False
		if not self.__connect():
			raise Exception
	def __close(self):
		if self.__connected:
			return False	
		self.__sock.close()
		self.__connected = False	
		return True
	def __connect(self):
		if self.__connected:
			return True		
		try:
			self.__sock.connect(self.__ADDR)	
		except:
			return False
		self.__connected = True
		return True
	def __recieveLine(self):
		if len(self.__buf) > 0:
			s = self.__buf[0]
			self.__buf = self.__buf[1:]			
			return s
		data = self.__sock.recv(65536)
		if not data:
			return False
		self.__buf = data.splitlines()
		return self.__recieveLine()
	def __checkString(self,str1,str2):
		if str1 == str2:
			return True
		elif str1 == str2 + "\n":
			return True
		return False		
	def __check(self,str):
		data = self.__recieveLine()
		if data == str:
			return True
		elif data == str+'\n':
			return True
		else:
			print "not expected",data,"expected",str
			return False
	def __sendcommand(self,c):
		if not self.__connected:
			if not self.__connect():
				raise Exception("Failed to connect")
		self.__sock.send(c+'\n')
		return self.__check('ok'+c)
	def __sendcommandargs(self,c,args):
		if not self.__connected:
			if not self.__connect():
				raise Exception("Failed to connect")
		self.__sock.send(c+'\n')		
		for arg in args:
			self.__sock.send(arg+'\n')
		return self.__check('ok'+c)
	def customCommand(self,cmd):
		return self.__sendcommand(cmd)
	def customCommandArgs(self,cmd,args):
		return self.__sendcommandargs(cmd,args)	
	def getSimData(self):
		if self.__busy: return None
		self.__busy = True
		if not self.__sendcommand('get'):
			return None		
		actors = {}
		newPreviousActors = []
		if not self.__check('startactors'):
			self.__busy = False
			return None
		while 1:
			data = self.__recieveLine()
			if self.__checkString(data,'endactors'):
				break			 
			_arr = data.split(',')
			arr = [0.0]*6
			for i in range(0,6): 
				arr[i] = float(_arr[i+1].lstrip())
				actors[_arr[0]] = arr;
			newPreviousActors.append(_arr[0])
		for i in self.__previousActors:
			if not actors.has_key(i):
				actors[i] = 'kill'
		self.__previousActors = newPreviousActors
		self.__busy = False
		return actors
	def showNativeRender(self):
		return self.__sendcommand('render')
	def ping(self):
		return self.__sendcommand('ping')
	def terminate(self):
		return self.__sendcommand('quit')
	def reset(self):
		return self.__sendcommand('reset')
		